#include "prehtml.h"

static int refermeauto=1; /* referme le fichier quand EOF rencontr ? */

int flag_reinclude=0; /* 1 si le <INCLUDE> est un <REINCLUDE> */

vector<fichier> fichiers;    
fichier *fichier_courant=NULL;

void ouvrir_fichier(const char *nom){ /* ouvre le premier fichier*/
	string ligne;
	if (structure) fprintf(stderr,"prehtml: ouverture du fichier principal %s\n",nom);
	if (fichiers.size()) erreur("ouvrir_fichier: dj ouvert");
	fichier nouvfichier;
	if (!(nouvfichier.fd=fopen(nom,"rb"))) 
		erreur("ouvrir_fichier: Impossible d'ouvrir le fichier %s",nom);
	nouvfichier.nom_fichier=nom;
	nouvfichier.numero_ligne=1;
	nouvfichier.profondeur=0;
	fichiers.push_back(nouvfichier);
	fichier_courant=&fichiers.back();
	ligne="file='"+string(nom)+"'"; execshell(ligne);
	ligne="thisfile='"+string(nom)+"'"; execshell(ligne);
}

void inclure_fichier(const char *nom){ /* ouvre un fichier inclus*/
	string ligne;
	int i;

	if (structure) {
		fprintf(stderr,"prehtml:  ");
		for(i=0;i<fichier_courant->profondeur; i++) fprintf(stderr," ");
		fprintf(stderr,"> inclusion du fichier %s\n",nom);
	}
	if (!fichier_courant) erreur("inclure_fichier: pas de fichier principal");
	fichier nouvfichier;
	if (!(nouvfichier.fd=fopen(nom,"rb"))){
		erreur("inclure_fichier: Impossible d'ouvrir le fichier %s",nom);
	}
	nouvfichier.nom_fichier=nom;
	nouvfichier.numero_ligne=1;
	nouvfichier.profondeur = fichier_courant->profondeur+1;
	ligne="thisfile='"+string(nom)+"'"; execshell(ligne);
	fichiers.push_back(nouvfichier);
	fichier_courant = &fichiers.back();
	if (!flag_reinclude){ /* inclusion normale */
		/* on cherche s'il y a un <BODY>, pour exclure l'entte */
		do{
			refermeauto=0; /* il ne faut pas que le fichier se referme si je trouve
			 * EOF (pour cause d'absence de <BODY>) */
			i=decode();
			refermeauto=1;
		}while (i!=EOF && (i!=EST_FONCTION || fonction.compare("body")));
		fseek(fichier_courant->fd,0,SEEK_SET);
		fichier_courant->numero_ligne=1;
		if (i==EST_FONCTION){ /* il y a un <BODY>, on va le sauter */
			do{
				i=decode();
			}while (i!=EST_FONCTION || fonction.compare("body"));
		}  /* s'il n'y en a pas, on reste au dbut du fichier */
	}
	else { /* inclusion spciale avec <REINCLUDE> */
		/* Gestion du <GENERATE> : 
		 * engenerate=0: pas dans <GENERATE>, rien de spcial  faire;
		 * engenerate=1: dans <GENERATE>, tronquer le fichier initial  zro
		 * engenerate=2: aprs </GENERATE>, c'est une erreur */
		if (engenerate==2) 
			erreur("<REINCLUDE %s> rencontr aprs </GENERATE>,\n"
			       "   c'est interdit car sans intrt",chaine.c_str());
		else if (engenerate==1)
			/* on tronque aussi le fichier commun du dbut, qui est ferm */
			truncate(fich_temp.c_str(),0);
		/* on ne cherche pas <BODY> car on n'enlve pas l'entte */
		/* par contre, on revient au dbut du fichier de sortie */
		fflush(sortie); /* on vide le buffer */
		rewind(sortie); /* on revient au dbut */
		ftruncate(fileno(sortie),0); /* puis on efface tout */
	}
}

/*private*/ fichier *fermer_fichier(void){ /*renvoie le fichier pre, ou NULL*/
	string ligne;
	int i;
	if (structure) {
		fprintf(stderr,"prehtml: ");
		for(i=0;i<fichier_courant->profondeur; i++) fprintf(stderr," ");
		fprintf(stderr,"< fermeture du fichier %s %s\n",(fichier_courant->profondeur?"inclus":"principal"),fichier_courant->nom_fichier.c_str());
	}
	fclose(fichier_courant->fd);
	fichiers.pop_back();
	if (fichiers.size()) fichier_courant = &fichiers.back();
	else fichier_courant=NULL;
	if (fichier_courant){
		ligne = "thisfile='" + fichier_courant->nom_fichier + "'";
		execshell(ligne);
	}
	return fichier_courant;
}

/* private */ int lit_un_caractere(void){ /* lit un caractre du systme de fichier*/
	int c;
	infoinclude *ceinc;
	while(1){
		c=getc(fichier_courant->fd);
		if (c=='\n') fichier_courant->numero_ligne ++;
		if (c!=EOF) return c;
		if (!refermeauto) return c; /* si on me demande de renvoyer EOF sans
		 * rien faire d'autre, j'obis */
		fermer_fichier(); /* c'est EOF, on ferme le fichier */
		/* en fait ce serait mieux de grer les fichiers inclus
		 * entirement comme une imbrication, et EOF comme une balise,
		 * mais je n'ai pas envie de tout reprendre */
		if (fichier_courant==NULL){
			if (imbriqueactu->type==imbrique::MAIN)
				return c; /* c'tait vraiment le top-niveau, EOF signale la fin */
			else erreur("Dernier EOF rencontr  l'intrieur d'un <%s>",
			            typeimbrique(imbriqueactu));
		}
		/* si je suis l, c'est EOF et il y a un fichier au-dessus */
		if (imbriqueactu->type==imbrique::MAIN) 
			erreur("lit_un_caractere(): Erreur interne: je suis dans "
			       "l'imbrication MAIN et je n'ai aucun fichier au-dessus de moi");
		if (imbriqueactu->type!=imbrique::INCLUDE)
			erreur("fin d'un fichier inclus rencontre  l'intrieur d'un <%s>",
			       typeimbrique(imbriqueactu));
		/* OK, c'est l'EOF d'un fichier inclus, je traite l'imbrication INCLUDE*/
		ceinc=&(imbriqueactu->info.pourinclude);
		ceinc->numfich++;
		if (ceinc->numfich < ceinc->liste.size()) /* ce n'est pas le dernier...*/
			inclure_fichier(ceinc->liste[ceinc->numfich].c_str()); /* ...au suivant */
		else{ /* l, c'tait le dernier */
			affiche=ceinc->affiche;
			referme_imbrique();
		}
		/* si on est toujours l, c'est qu'il faut retenter de lire un caractre */
	}
}

static int stockage=0; /* en train de stocker? */
static int destockage=0; /* en train de lire une chaine stockee? */
static string stock;
static size_t plitchaine;
/*longueur=espace rserv pour chainestock, plitchaine=pointeur pour
 * le dstockage, pecritchaine=pointeur pour le stockage,
 * nbcarchaine=nb de caractres effectivement stocks*/
static int eof=0; /* EOF rencontr pendant le stockage? */

int mongetc(void){
	int c;
	if (destockage){
		c=stock[plitchaine++];
		if (plitchaine==stock.size()) {
			destockage=0;
			stock.clear();
		}
	}
	else { 
		if (eof) c=EOF; else c=lit_un_caractere();
	}
	if (stockage) {
		if (c==EOF) eof=1;
		else{
			stock += c;
		}
	}
	return c;
}

void stocke(void){ /* commence  accumuler des caractres, pour pouvoir
	 * les ressortir si la fonction qu'on croyait
	 * reconnatre n'tait pas celle que l'on croyait*/
	if (stockage) erreur("stocke(): erreur car stockage est dj vrai");
	stockage=1; eof=0;
	if (!destockage){ /* on est en train de lire depuis le fichier*/
		stock.clear();
	}else{ /* on est dj en train de lire la chaine stockee */
		/*on dcale la chaine pour que a commence bien au dbut*/
		/* (permet  destockage() de bien marcher */
		stock.erase(0,plitchaine);
		plitchaine=0;
	}
}

void finstocke(void){ /* limine les caractres stocks */
	if (!stockage) erreur("finstocke(): erreur car stockage est faux");
	stockage=0;
	if (!destockage) /* on lisait depuis le fichier: la chaine doit tre limine*/
		stock.clear();
	/* sinon, on lisait dj une chaine stocke: rien  faire, on continue*/
}

void destocke(void){ /* repart  l'endroit o on a stock */
	if (!stockage) erreur("destocke(): erreur car stockage est faux");
	stockage=0;
	destockage=1;
	plitchaine=0;
}

/*private*/ void dit_ou_pere(fichier *fich){
	if (fich->profondeur){ /*celui-ci non plus n'est pas le top-niveau*/
		dit_ou_pere(&fichiers[fich->profondeur-1]);
		fprintf(stderr,"  ");
	}
	fprintf(stderr,"dans fichier inclus depuis %s:%ld:\n",
	        fich->nom_fichier.c_str(),fich->numero_ligne);
}

void dit_ou(void){ /* dit o on est dans le fichier, et via quelles
	 * inclusions, pour faire message d'erreur;
	 * sort dans stderr et n'inclut pas de '\n'*/
	if (destockage)
		fprintf(stderr,"attention: position approximative car en destockage\n");
	if (!fichier_courant) {
		fprintf(stderr," EOF ou fichier non ouvert: ");
		return;
	}
	if (fichier_courant->profondeur){ /* on est dans un fichier inclus*/
		dit_ou_pere(&fichiers[fichier_courant->profondeur-1]);
		fprintf(stderr,"  ");
	}
	fprintf(stderr,"%s:%ld: ",fichier_courant->nom_fichier.c_str(),
	        fichier_courant->numero_ligne);
}  

FILE *quelfichier(void){ /* dit dans quel fichier on se trouve */
	return fichier_courant->fd;
}

off_t queloffset(void){ /* donne la position actuelle dans le fichier */
	/* on gre le destockage mais normalement a ne devrait jamais arriver */
	return ftell(fichier_courant->fd)+(destockage?plitchaine:0);
}

int quelleligne(void){ /* idem: dit  quelle ligne on est */
	return fichier_courant->numero_ligne;
}

void revient(FILE *fich,off_t pos,int ligne){ /* tente de revenir, mais vrifie
	 * qu'on est dans le mme fichier*/
	if (fichier_courant->fd != fich){
		erreur("<%s>: on n'est plus dans le mme fichier qu'au dbut!",fonction.c_str());
	}
	fseek(fich,pos,SEEK_SET);
	fichier_courant->numero_ligne=ligne;
	stockage=0;
	destockage=0;
}
